#
######################################################
-test -t 0 && echo stdin # ????
-test -t 1 && echo stdout # ????
-test -t 2 && echo stderr # ????
set -e
if test -z "${MH_OBJ_DIR}"; then
setup_test
require_prog script
-#### FreeBSD script, e.g., doesn't use -c to identify a command to run.
-if script -c 'echo OK' /dev/null 2>&1 | egrep 'OK' >/dev/null; then
- script_command_opt='-c'
+
+actual="${MH_TEST_DIR}/test-version-check$$.actual"
+context="${MH_TEST_DIR}"/Mail/context
+version="Version: nmh-${MH_VERSION}"
+cmd="${MH_TEST_DIR}/Mail/cmd"
+
+#### Hack: especially on multicore/multiprocessor machines, need
+#### to allow time for the output file to be closed. If the output
+#### file never reaches a size greater than zero after waiting for
+#### a short while, let a subsequent check fail to find what it needs.
+#### $1: pid to wait for
+#### $2: output file that must eventually have non-zero size
+wait_for_script() {
+ wait $1
+
+ for i in 1 2 3 4 5 6 7 8 9 10; do
+ test -s "$2" && break || sleep 1
+ done
+}
+
+
+if script -S /bin/sh 'echo OK' /dev/null 2>&1 | egrep 'OK' >/dev/null; then
+ #### script(1) uses -S to set the shell that it runs.
+ use_dash_S=1
else
- script_command_opt=''
+ cat >"${cmd}" <<EOF
+#! /bin/sh
+echo OK
+EOF
+ chmod +x "${cmd}"
+
+ (SHELL="${cmd}"; export SHELL; script "${actual}" >/dev/null &
+ wait_for_script $! "${actual}")
+ if grep OK "${actual}" >/dev/null; then
+ #### script(1) supports SHELL environment variable.
+ use_dash_S=0
+ else
+ test_skip "can't find mechanism to set SHELL for script(1)"
+ fi
fi
#### Run a command but don't wait for user input. script(1) seems to do
-#### what we want by not waiting when run in the background.
+#### what we want by not waiting when run in the background. But check
+#### that it makes the command look like it's connected to a terminal below.
run_without_input() {
- if [ "$script_command_opt" = -c ]; then
- #### -c takes single argument with command + arguments.
- script -q -f -c "$*" "$actual" >/dev/null &
+ #### Create a command to use as a shell for script.
+ cat >"${cmd}" <<EOF
+#! /bin/sh
+$*
+EOF
+ chmod +x "${cmd}"
+
+ if [ ${use_dash_S} -eq 1 ]; then
+ script -S "${cmd}" "${actual}" >/dev/null &
else
- #### E.g., FreeBSD. Don't combine command arguments.
- script -q -t 0 "$actual" "$@" >/dev/null &
+ SHELL="${cmd}" script "${actual}" >/dev/null &
fi
- wait $!
+ wait_for_script $! "${actual}"
}
-actual="$MH_TEST_DIR/test-version-check$$.actual"
-context="${MH_TEST_DIR}"/Mail/context
-version="Version: nmh-${MH_VERSION}"
+#### Ensure that script(1) makes the program look like it's connected to a
+#### terminal. The welcome message code in sbr/utils.c needs that.
+run_without_input 'if test -t 0 -a -t 1 -a -t 2; then echo tty; fi'
+grep tty "${actual}" >/dev/null || test_skip "script(1) doesn't simulate tty"
+
# Removing Version will trigger the welcome message. (setup_test
# inserted it so that other tests wouldn't show it.)
-grep -v Version "$context" > "$context.NEW"
-mv -f "$context.NEW" "$context"
+grep -v Version "${context}" > "${context}.NEW"
+mv -f "${context}.NEW" "${context}"
start_test 'mhparam skips the welcome message'
run_without_input mhparam path
-grep 'Welcome to nmh version ' "$actual" >/dev/null && false
+grep 'Welcome to nmh version ' "${actual}" >/dev/null && false
# Make sure that version wasn't added to context.
grep "^${version}$" "${MH_TEST_DIR}/Mail/context" >/dev/null && false
-rm "$actual"
+rm "${actual}"
start_test 'Welcome: disable in profile skips the welcome message'
cp "${MH}" "${MH}-welcome"
printf 'Welcome: disable\n' >> "${MH}-welcome"
-(MH="${MH}-welcome" run_without_input pick last)
-grep 'Welcome to nmh version ' "$actual" >/dev/null && false
+# Run the function in subshell instead of augmenting the environment
+# for a single command, so that the environment does not retain the
+# MH setting. That can happen when run under distcheck, depending
+# on the user's shell.
+(MH="${MH}-welcome"; run_without_input pick last)
+rm "${MH}-welcome"
+grep 'Welcome to nmh version ' "${actual}" >/dev/null && false
# Make sure that version wasn't added to context.
grep "^${version}$" "${MH_TEST_DIR}/Mail/context" >/dev/null && false
-rm "$actual"
+rm "${actual}"
start_test 'with welcome message'
run_without_input pick last
-grep 'Welcome to nmh version ' "$actual" >/dev/null
+grep 'Welcome to nmh version ' "${actual}" >/dev/null
# Make sure that version was added to context.
grep "^${version}$" "${MH_TEST_DIR}/Mail/context" >/dev/null
-rm "$actual"
+rm "${actual}"
start_test 'without welcome message'
# After running the previous test, this one should not have
# the welcome message.
run_without_input pick last
-grep 'Welcome to nmh version ' "$actual" >/dev/null && false
+grep 'Welcome to nmh version ' "${actual}" >/dev/null && false
# Make sure that version is still in context.
grep "^${version}$" "${MH_TEST_DIR}/Mail/context" >/dev/null
-rm "$actual"
+rm "${actual}"
start_test 'with MHCONTEXT, welcome only if older'
MHCONTEXT="${MH_TEST_DIR}/Mail/context2"; export MHCONTEXT
printf 'Version: nmh-1.5\n' >"${MHCONTEXT}"
run_without_input pick last
-grep 'Welcome to nmh version ' "$actual" >/dev/null
+grep 'Welcome to nmh version ' "${actual}" >/dev/null
# And make sure that version did get updated in context.
grep "^${version}$" "${MHCONTEXT}" >/dev/null
-rm "$actual"
+rm "${actual}"
start_test "with MHCONTEXT doesn't welcome if newer"
printf 'Version: nmh-10000.0\n' >"${MHCONTEXT}"
run_without_input pick last
-grep 'Welcome to nmh version ' "$actual" >/dev/null && false
+grep 'Welcome to nmh version ' "${actual}" >/dev/null && false
# And make sure that version didn't get updated in context.
grep '^Version: nmh-10000.0$' "${MHCONTEXT}" >/dev/null
-rm "$actual"
+rm "${actual}"
start_test 'with MHCONTEXT but no version, no welcome and update'
printf '' >"${MHCONTEXT}"
run_without_input pick last
-grep 'Welcome to nmh version ' "$actual" >/dev/null && false
+grep 'Welcome to nmh version ' "${actual}" >/dev/null && false
# And make sure that version did get updated in context.
grep "^${version}$" "${MHCONTEXT}" >/dev/null
-rm "$actual"
+rm "${actual}"
finish_test
-exit $failed
+exit ${failed}